//
// Copyright (C) 2000 Software Resources International SA
//
// This code is provided on an 'as is' basis.
// Software Resources International SA carries no responsibility for
// the application of this code in any way or form.
//

#ifndef __DEVIO_H__
#define __DEVIO_H__

#include "definitions.h"
#include "f11lib_share.h"

// Open file mode
#define DEVIO_RO (1)
#define DEVIO_WO (0)
#define DEVIO_RW (0)

#define INVALID_CHAN (-1)

// This function opens device with given name and flag.
// Returns device channel or -1 in case of error 
gblfunc_f11lib int  devio_open_dev(const char* dev_name, int mode);

// This function closes device
gblfunc_f11lib void devio_close_dev(int dev_chan);

// This function reads device block(s)
// It returns number of bytes read, or -1
// Buffer size must be greater or equal to blk_count * F11_BLOCK_SIZE
gblfunc_f11lib int  devio_read_dev(int dev_chan, int blk_number, 
				   int blk_count, void* buffer);

// This function writes device block
// It returns number of bytes write, or -1
// Buffer size must be greater or equal to blk_count * F11_BLOCK_SIZE
gblfunc_f11lib int  devio_write_dev(int dev_chan, int blk_number,
				    int blk_count, void* buffer);

// Those functions return status of last operation 
gblfunc_f11lib int	devio_dev_error(void);
gblfunc_f11lib char*	devio_dev_error_msg(void);

#endif
