//
// Copyright (C) 2000 Software Resources International SA
//
// This code is provided on an 'as is' basis.
// Software Resources International SA carries no responsibility for
// the application of this code in any way or form.
//

#ifndef __F11DIR_H__
#define __F11DIR_H__

#include "files11.h"
#include "f11file.h"

class f11_directory : public f11_file
{
public:

    f11_directory() {}

    virtual int	is_valid(const ODS_FID* back_fid) const {
	if (!get_fhdr()->is_file_directory()) return 0;
	return f11_file::is_valid(back_fid);
    }

    ODS_dir_entry*  f11_direntry_lookup(
	    const char*		fspec, 
	    word_t		wild,
	    ODS_dir_record*	start_dr,
	    byte_t		ct2,
	    ODS_dir_record**    p_dr,
	    ODS_dir_record**    p_cur_dr = NULL
    ) const;

    void    remove_dir_entry(
	    ODS_dir_record*	dr,
	    ODS_dir_entry*	e
    );

    void    decompose_wcc(
	    dword_t		wcc, 
	    ODS_dir_record**	p_dr,
	    ODS_dir_entry**	p_e,
	    byte_t*		p_ct2
    );

    dword_t compose_wcc( 
	    ODS_dir_record* p_dr,
	    byte_t	    ct2
    );

    ODS_dir_record*	f11_get_next_record(ODS_dir_record* dr) const;
};

#endif 	// __F11LIBEX_H__
